;-- http://radiohlam.ru -  ,   
;------------------------------------------------------------------
 list    p = 12f629
	#include <p12f629.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

   
 __config 03194h          ;  ,   
                           
;*********  ************************************
         CBLOCK 0x20      ;                 
         T_Cr             ; 
         T_NC             ;    
         T_0              ;   
         LBC              ;  
         MBC              ;  
         ENDC             ;
;********  ***************************************
Cr1         equ         .2          ;  1 
Cr0         equ         .4          ;  0 
NCr         equ         .32         ;       ( - 889uS)
Sys         equ         .0          ;  
CMD_1       equ         .32         ;   1
CMD_2       equ         .16         ;   2
CMD_3       equ         .33         ;   3
CMD_4       equ         .17         ;   4
Status      equ         03h         ;   .
GPIO        equ         05h         ;    .
Cmcon       equ         19h         ;  Cmcon - 
TrisIO      equ         05h         ;      .
INTCON      equ         0Bh         ;  (1)/(0) 
;OSCCAL      equ         10h         ;    
F           equ         1           ;    .
;********************************************************
;    GP0 -     , GP1, GP2, GP4, GP5 - 
;********************************************************

          org 0
          goto start
          org 4
          nop
          retfie
;********   ********************************************************
;***  ,      , **********
;***    , OSCCAL    03FFh,     BOR - *
;*** 12-,13-    (   BOR - 01, OSCCAL - 3458)*****************
start      
;******   *****************************************************************
            bsf         Status,5    ;
            Call        3FFh        ;     w
            movwf       OSCCAL      ;       
;********     ************************************************
            bcf         Status,5    ;    0
            clrf        GPIO        ;   (   )
            movlw       .7          ;  0..2 
            movwf       Cmcon       ;  , GP0, GP1, GP2 -  /
            bsf         Status,5    ;   1-  (  1 5-   Status)
      	bcf 0x01,7
            movlw       .62         ;   GPIO   (W)    .62=00 111110 GP0 - ,  - 
            movwf       TrisIO      ;   GPIO  W   TrisIO.

            movlw b'00110110'
            movwf IOCB

            bcf         Status,5    ;   0-  (  0 5-   Status)
            
            bsf INTCON,GPIE
            bcf INTCON,GIE

;********     *************************************************
            movlw   Sys
            movwf   MBC             ;      
            bsf     MBC,6           ; 
            bsf     MBC,7           ; 

;******   **********************************************************************
Scan       btfss   GPIO,5           ;    GP5   -   1
           goto    Tx_CMD1          ;
           btfss   GPIO,2           ;    GP2   -   2
           goto    Tx_CMD2          ;
           btfss   GPIO,4           ;    GP4   -   3
           goto    Tx_CMD3          ;
           btfss   GPIO,1           ;    GP1   -   4
           goto    Tx_CMD4          ;
           bsf     MBC,5            ;     1 ( )
           bcf  INTCON,GPIF 
            movf GPIO,w
            movwf GPIO
             sleep
               nop 
            bcf  INTCON,GPIF  
              
           goto Scan                ;

;******     ***************************************************
Tx_CMD1  movlw   CMD_1             ;
         movwf   LBC               ;   1    
         goto    TxRC              ;
;************************
Tx_CMD2  movlw   CMD_2             ;
         movwf   LBC               ;   2    
         goto    TxRC              ;
;************************
Tx_CMD3  movlw   CMD_3             ;
         movwf   LBC               ;   3    
         goto    TxRC              ;
;************************
Tx_CMD4  movlw   CMD_4             ;
         movwf   LBC               ;   4    
         goto    TxRC              ;
;*********************************************************************************************
;*******   RC-5 ****************************************************************
TxRC    btfsc   MBC,7            ; Startbit 1.    1,   Tx_1,
        call    Tx_1             ;    ,   Tx_0
        btfss   MBC,7            ;   
        call    Tx_0             ;
;--------------------------------
         btfsc   MBC,6           ; Startbit 2
         call    Tx_1            ;
         btfss   MBC,6           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   MBC,5           ; Control bit
         call    Tx_1            ;
         btfss   MBC,5           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   MBC,4           ; System bit 4
         call    Tx_1            ;
         btfss   MBC,4           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   MBC,3           ; System bit 3
         call    Tx_1            ;
         btfss   MBC,3           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   MBC,2           ;System bit 2
         call    Tx_1            ;
         btfss   MBC,2           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   MBC,1           ;System bit 1
         call    Tx_1            ;
         btfss   MBC,1           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   MBC,0           ;System bit 0
         call    Tx_1            ;
         btfss   MBC,0           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   LBC,5           ;Command bit 5
         call    Tx_1            ;
         btfss   LBC,5           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   LBC,4           ;Command bit 4
         call    Tx_1            ;
         btfss   LBC,4           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   LBC,3           ;Command bit 3
         call    Tx_1            ;
         btfss   LBC,3           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   LBC,2           ;Command bit 2
         call    Tx_1            ;
         btfss   LBC,2           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   LBC,1           ;Command bit 1
         call    Tx_1            ;
         btfss   LBC,1           ;
         call    Tx_0            ;
;--------------------------------
         btfsc   LBC,0           ;Command bit 0
         call    Tx_1            ;
         btfss   LBC,0           ;
         call    Tx_0            ;
         bcf     MBC,5           ;   
;****** ,    ****************************************************
;******     50 bit, ..   100   (RCN) ********
         movlw   .99             ;   99,   100, ..  call   
         movwf   T_0
pause    call    RCN
         decfsz  T_0,F           ;  T_0
         goto    pause           ;
         goto    Scan                       
;********    **********************************************************************
;--------------------------------------------------------------------------------------------------------

;*******      ************************************************
;*******     **********************
Tx_0    call RCY                 ;   
        call RCN                 ;   
        return                   ;
;*******     *******************
Tx_1    call RCN                 ;   
        call RCY                 ;   
        return                   ;
;*********************************************************************************************

;*****          ***********************
;*****    ******************
RCY      movlw   NCr            ;   NCr  
         movwf   T_NC           ;      T_NC
Y_001    movlw   Cr1            ;   Cr1  
         movwf   T_Cr           ;      T_Cr ( )
         bsf     GPIO,0         ;     GP0  ( 1  )
Cr1_Y    decfsz  T_Cr,F         ;    T_Cr  :  f=0 -    ,  f=1 - 
                                ;    T_Cr.     0,    ,   0,  
                                ;    nop,     2 ..
         goto    Cr1_Y          ;    Cr1_Y
         bcf     GPIO,0         ;     GP0  ( 0  )
         movlw   Cr0            ;   Cr0  
         movwf   T_Cr           ;      T_Cr
Cr0_Y    decfsz  T_Cr,F         ;
         goto    Cr0_Y          ;
         decfsz  T_NC,F         ;
         goto    Y_001          ;
         return                 ;
;*****    *******************
RCN      movlw   NCr            ;
         movwf   T_NC           ;
N_001    movlw   Cr1            ;
         movwf   T_Cr           ;
         nop                    ;  bsf GPIO
         nop                    ; 
Cr1_N    decfsz  T_Cr,F         ;
         goto    Cr1_N          ;
         nop
         nop                    ;  bf GPIO
         nop                    ; 
         movlw   Cr0            ;
         movwf   T_Cr           ;
Cr0_N    decfsz  T_Cr,F         ;
         goto    Cr0_N          ;
         decfsz  T_NC,F         ;
         goto    N_001          ;
         return                 ;
;***********************************************************************************************
        end